package testJSON;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;

import ws_api.RespuestaTimbrado;
import ws_api.ServicioTimbradoWSPortTypeProxy;
import ws_util.Base64;

public class Conexion {
	
	public static void main(String[] args) {		
		String wsdl = "https://dev.facturaloplus.com/ws/servicio.do?wsdl";
		try {
			// SE CREA OBJETO DE CONEXIN
			ServicioTimbradoWSPortTypeProxy cte = new ServicioTimbradoWSPortTypeProxy(wsdl);
			File pathIn;
			
			// SE CARGA String EN Base64 DEL JSON CON INFORMACIN DEL CFDI
			pathIn = new File("C:\\Users\\Neo\\Dropbox\\Workspace\\Facturalo\\kitTimbradorXpress\\cfdiXpress_ejemplo.json");
			String jsonCFDI = Base64.encodeBytes(Files.readAllBytes(pathIn.toPath()));
			
			// SE CARGA CONTENIDO DEL PEM DEL ARCHIVO .key
			pathIn = new File("C:\\Users\\Neo\\Desktop\\elementos_cfdi33\\dev\\CSD01_AAA010101AAA_key.pem");
			String keyPEM = new String(Files.readAllBytes(pathIn.toPath()));
	
			// SE CARGA CONTENIDO DEL PEM DEL ARCHIVO .cer
			pathIn = new File("C:\\Users\\Neo\\Desktop\\elementos_cfdi33\\dev\\CSD01_AAA010101AAA_cer.pem");
			String cerPEM = new String(Files.readAllBytes(pathIn.toPath()));
			
			// SE INVOCA AL MTODO QUE TIMBRA Y OBTIENE XML Y PDF
			RespuestaTimbrado res = cte.timbrarJSON2("d775313407bc4d56984a039cf2bf30a1", jsonCFDI, keyPEM, cerPEM, "1");
			
			// SE MUESTRA OBJETO DE RESPUESTA: CDIGO Y MENSAJE
			System.out.println("Cdigo: "+res.getCode());
			System.out.println("Mensaje: "+res.getMessage());
			
			// SI EL CFDI SE TIMBR POR PRIMERA VEZ (CDIGO 200) 
			// SI EL CFDI YA SE HABA TIMBRADO ANTES (CDIGO 307),
			// SE OBTIENE String DEL XML Y String EN Base64 DEL PDF.
			if (res.getCode().equals("200") || res.getCode().equals("307")) {
				System.out.println("Datos: \n"+res.getData());
			}
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	
	}
}
